<template>
  <!-- The sidebar -->
  <!-- Because it closes on focus loss,
    it's important to use the 'attach' prop on any select  -->
  <v-navigation-drawer
    app
    :color="$store.state.secondaryColor"
    :width="400"
    :mini-variant="isMinified"
    permanent
  >
    <template #prepend>
      <sidebar-title
        :is-minified.sync="isMinified"
      />

      <v-list nav>
        <piece-search-box
          v-model="isMinified"
          :clients="clients"
        />
      </v-list>
    </template>
    <template #default>
      <!-- Page specific buttons -->
      <!-- Passes isMinified as a prop to change display -->
      <portal-target
        :slot-props="{ isMinified }"
        name="sidebar-buttons"
      />
    </template>
    <template #append>
      <v-list nav dense>
        <corpora-cards-button />
        <corpus-table-button />
        <login-button v-model="isMinified" :client="loginClient" />
        <!-- <piece-upload-button :client="loginClient" /> -->
        <block-users-button :client="loginClient" />
        <auto-player-switch />
        <about-button />
        <help-button />
        <locale-switcher />
      </v-list>
    </template>
  </v-navigation-drawer>
</template>
<script lang="ts">
import {
  Vue, Component, Prop, Watch,
} from 'vue-property-decorator';
import type { Client } from '@/client';
import SidebarTitle from './SidebarTitle.vue';
import LoginButton from './buttons/LoginButton.vue';
import PieceSearchBox from './buttons/PieceSearchBox.vue';
import AboutButton from './buttons/AboutButton.vue';
import HelpButton from './buttons/HelpButton.vue';
import LocaleSwitcher from './buttons/LocaleSwitcher.vue';
import PieceUploadButton from './buttons/PieceUploadButton.vue';
import BlockUsersButton from './buttons/BlockUsersButton.vue';
import CorporaCardsButton from './buttons/CorporaCardsButton.vue';
import CorpusTableButton from './buttons/CorpusTableButton.vue';
import AutoPlayerSwitch from './buttons/AutoPlayerSwitch.vue';

@Component({
  components: {
    PieceSearchBox,
    SidebarTitle,
    LoginButton,
    AboutButton,
    HelpButton,
    LocaleSwitcher,
    PieceUploadButton,
    BlockUsersButton,
    CorporaCardsButton,
    CorpusTableButton,
    AutoPlayerSwitch,
  },
})
export default class Sidebar extends Vue {
  isMinified = (localStorage.getItem('sidebarMinified') || 'true') === 'true';

  @Prop({ default: [] })
  clients!: Client[];

  @Prop({ default: null })
  loginClient!: Client | null;

  created() {
    this.onChangeMiniVariant();
  }

  @Watch('isMinified')
  onChangeMiniVariant() {
    localStorage.setItem('sidebarMinified', this.isMinified ? 'true' : 'false');
  }
}
</script>
<style scoped lang="scss">

// Override vuetify navbar title hide
// Prevents titles from disappearing during mini transition
::v-deep .v-navigation-drawer--mini-variant .v-list-item > :not(:first-child)
{
  position: inherit !important;
  height: initial;
  width: initial;
  overflow: initial;
  clip: initial;
  white-space: initial;
  display: flex;
}
::v-deep .v-navigation-drawer--mini-variant .v-list-item > :first-child {
  margin-right: 32px;
}

</style>
